# Cache gems in between builds
cache:
  paths:
    - vendor/ruby
stages:
  - build
  - test
  - deploy

.check_version_number:
  - &check_version_number
    |
      if [ "$CI_COMMIT_TAG" != "" ] && [ "$(sed "s/^.*VERSION = '\(.*\)'$/\1/p" -n lib/watt_sense_api/version.rb)" != "$CI_COMMIT_TAG" ]; then
        echo "Ensure tag name (here: '$CI_COMMIT_TAG') is equals to the version set in \`lib/watt_sense_api/version.rb\`"
        exit 1
      fi

build:
  stage: build
  rules:
    - if: $CI_COMMIT_TAG && $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+/
      when: always
    - if: $CI_COMMIT_TAG
      when: manual
  artifacts:
    paths:
      - '*.gem'
  script:
    - *check_version_number
    - gem build ${CI_PROJECT_NAME}.gemspec

doc build:
  stage: build
  rules:
    - if: $CI_COMMIT_TAG && $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+/
      when: always
    - if: $CI_COMMIT_TAG
      when: manual
  before_script:
    - gem install bundler
    - bundle config set with development
    - bundle install
  script:
    - *check_version_number
    - bundle exec yard
  artifacts:
    paths:
      - doc/

.test_base:
  stage: test
  before_script:
    - gem install bundler
    - bundle config set with test
    - bundle install
  script:
    - bundle exec rspec
  rules:
    - if: $CI_COMMIT_BRANCH == 'main' || $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+/
      when: on_success
    - if: $CI_COMMIT_BRANCH != 'main'
      when: manual
    - if: $CI_COMMIT_TAG
      when: manual

test ruby 2.6:
  extends: .test_base
  image: ruby:2.6

test ruby 3.0:
  extends: .test_base
  image: ruby:3.0
  artifacts:
    paths:
      - coverage/
  coverage: '/\(\d+.\d+\%\) covered/'

rubocop:
  stage: test
  before_script:
    - gem install bundler
    - bundle config set with development
    - bundle install
  script:
    - bundle exec rubocop
  rules:
    - if: $CI_COMMIT_BRANCH == 'main' || $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+/
      when: on_success
    - if: $CI_COMMIT_BRANCH != 'main'
      when: manual
    - if: $CI_COMMIT_TAG
      when: manual

bundle audit:
  stage: test
  before_script:
    - gem install bundler bundler-audit
    - bundle install
  script:
    - bundle audit update
    - bundle audit check
  rules:
    - if: $CI_COMMIT_BRANCH == 'main' || $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+/
      when: on_success
    - if: $CI_COMMIT_BRANCH != 'main'
      when: manual
    - if: $CI_COMMIT_TAG
      when: manual

pages:
  stage: deploy
  rules:
    - if: $CI_COMMIT_TAG && $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+/
      when: on_success
    - if: $CI_COMMIT_TAG
      when: manual
  needs:
    - job: doc build
      artifacts: true
    - test ruby 2.6
    - job: test ruby 3.0
      artifacts: true
    - rubocop
    - bundle audit
  script:
    - mv coverage doc/
    - mkdir -p public
    - mv doc public/$CI_COMMIT_TAG
  artifacts:
    paths:
      - public

gem deploy:
  stage: deploy
  rules:
    - if: $CI_COMMIT_TAG && $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+/
      when: on_success
    - if: $CI_COMMIT_TAG
      when: manual
  needs:
    - job: build
      artifacts: true
    - test ruby 2.6
    - test ruby 3.0
    - rubocop
    - bundle audit
  script:
    - mkdir -p ~/.gem
    - echo --- > ~/.gem/credentials
    - 'echo :rubygems_api_key: \"$RUBYGEMS_RLAURES_PUSH_KEY\" >> ~/.gem/credentials'
    - chmod 0600 ~/.gem/credentials
    - gem push *.gem
